using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.DirectoryServices; 

// Authour : Gnana Prakash S
// Email Id: sgnanaprakash@gmail.com
// Webiste :www.sgnanaprakash.com

public partial class _Default : System.Web.UI.Page 
{
    //private string _adPath = ConfigurationManager.AppSettings["AdPath"].ToString();
    private String _adrootPath = ConfigurationManager.AppSettings["AdPathRoot"].ToString();
    //private String _userName = ConfigurationManager.AppSettings["UserName"].ToString();
    //private String _password = ConfigurationManager.AppSettings["Password"].ToString();
    private bool _IsStatus = false;
    private bool _IsFromUser = false;
    
      
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            hdnAdPath.Value  = ConfigurationManager.AppSettings["AdPathRoot"].ToString();
            hdnUserName.Value = ConfigurationManager.AppSettings["UserName"].ToString();
            hdnUserPassword.Value = ConfigurationManager.AppSettings["Password"].ToString();
            tvDomainController.Visible = false;
            lblStatus.Visible = false;
             
            
            // Check whether Domain Server availble or not.
            CheckSystemLevel();

        }

        tvDomainController.Attributes.Add("OnTreeNodeCollapsed", "Javascript: OnCheckBoxCheckChanged(event);");
        tvDomainController.Attributes.Add("OnTreeNodeExpanded ", "Javascript: OnCheckBoxCheckChanged(event);");

    }


    protected void CheckSystemLevel()
    {
        
        // Get the  Domain Name
        String DomainName = Environment.UserDomainName.ToString();


        // Get Domain Server name
        String domainserverName = Environment.GetEnvironmentVariable("LOGONSERVER");

        // Get Local System Name
        string localSystemName = Environment.MachineName.ToString();


        // Check whether system in domain control or not
        if (!domainserverName.Contains(localSystemName) && DomainName != localSystemName)
        {
            // Client Machine
            // System is connection to Domain Server
            hdnStatus.Value =  "false";
            LoadDomainName();
        }
        else if (DomainName == localSystemName && domainserverName.Contains(localSystemName))
        {

            // Local System ???
            // System is not having domaincontroller
            hdnStatus.Value= "true";
            LoadDomainDetailswithPath(); 


        }

        else if (domainserverName.Contains(localSystemName) && DomainName != localSystemName)
        {

            // Domain Controller System
            // server System
           hdnStatus.Value =  "false";
            LoadDomainName();

        }

        

    }


    protected void LoadDomainName()
    {
        try
        {
            DirectoryEntry adRootDSE = new DirectoryEntry(_adrootPath);
            DirectoryEntry adRoot = new DirectoryEntry("LDAP://" + (string)adRootDSE.Properties["defaultNamingContext"].Value);

            TreeNode tnRoot = new TreeNode();

            tnRoot.Text = adRoot.Properties["Name"].Value.ToString();
            tnRoot.Value = adRoot.Path.ToString().Replace("/", "\\");
            tnRoot.SelectAction = TreeNodeSelectAction.Expand;
            tnRoot.PopulateOnDemand = true;
            tnRoot.ShowCheckBox = false;
            tnRoot.ImageUrl = adImageURL[(int)AdImages.AdRoot];
            tvDomainController.Nodes.Clear();
            tvDomainController.Nodes.Add(tnRoot);
            tvDomainController.Visible = true;
            lblStatus.Visible = false;
        }
        catch (Exception ex)
        {
            lblStatus.Text = "Directory expecting username and password"; 
            lblStatus.Visible = true;
            tvDomainController.Visible = false;
        }
    }


    private void LoadDomainDetailswithPath()
    {

        if (AuthenticateUser(hdnAdPath.Value, hdnUserName.Value, hdnUserPassword.Value))
        {            
            lblStatus.Visible = false;

            DirectoryEntry adRoot = new DirectoryEntry(hdnAdPath.Value, hdnUserName.Value, hdnUserPassword.Value);

            TreeNode tnRoot = new TreeNode();

            tnRoot.Text = adRoot.Properties["Name"].Value.ToString();
            tnRoot.Value = adRoot.Path.ToString().Replace("/", "\\");
            tnRoot.SelectAction = TreeNodeSelectAction.Expand;
            tnRoot.PopulateOnDemand = true;
            tnRoot.ShowCheckBox = false;
            tnRoot.ImageUrl = adImageURL[(int)AdImages.AdRoot];
            tvDomainController.Nodes.Clear();
            tvDomainController.Nodes.Add(tnRoot);
            //tvDomainController.ExpandDepth = 0; 

        }
        else
        {
            lblStatus.Text = "The specified domain either does not exist or could not be contacted.\nLogon failure: unknown user name or bad password.";
            lblStatus.Visible = true;
            tvDomainController.Visible = false; 
        }

        


    }


    protected void PopulateNode(Object source, TreeNodeEventArgs e)
    {

        if (e.Node.Value != string.Empty)
        {
            DirectoryEntry selectedEntry;

            if (hdnStatus.Value == "false" )
            {
                selectedEntry = new DirectoryEntry(e.Node.Value.Replace("\\", "/"));
            }
            else
            {
                selectedEntry = new DirectoryEntry(e.Node.Value.Replace("\\", "/"), hdnUserName.Value, hdnUserPassword.Value);
            }



            if (DirectoryEntry.Exists(selectedEntry.Path))
            {

                foreach (DirectoryEntry child in selectedEntry.Children)
                {
                    TreeNode tvNode = e.Node;
                    TreeNode tmpNode = new TreeNode();


                    switch (child.SchemaClassName)
                    {
                        case "organizationalUnit":
                            tmpNode.Text = child.Properties["Name"].Value.ToString();
                            tmpNode.Value = child.Path.ToString().Replace("/", "\\");
                            tmpNode.SelectAction = TreeNodeSelectAction.Expand;
                            tmpNode.PopulateOnDemand = true;
                            tmpNode.ImageUrl = adImageURL[(int)AdImages.Ou];

                            tvNode.ChildNodes.Add(tmpNode);
                            break;

                        case "container":

                            tmpNode.Text = child.Properties["Name"].Value.ToString();
                            tmpNode.Value = child.Path.ToString().Replace("/", "\\");
                            tmpNode.SelectAction = TreeNodeSelectAction.Expand;
                            tmpNode.PopulateOnDemand = true;                               
                            tmpNode.ImageUrl = adImageURL[(int)AdImages.Container];
                            tvNode.ChildNodes.Add(tmpNode);                           
                            break;

                        case "computer":
                            tmpNode.Text = child.Properties["Name"].Value.ToString() + child.SchemaClassName.ToString();
                            tmpNode.Value = child.Path.ToString().Replace("/", "\\");
                            tmpNode.SelectAction = TreeNodeSelectAction.Expand;
                            tmpNode.PopulateOnDemand = true;
                            tmpNode.ImageUrl = adImageURL[(int)AdImages.Computer];
                            tvNode.ChildNodes.Add(tmpNode);
                            break;

                        case "user":
                            tmpNode.Text = child.Properties["Name"].Value.ToString();
                            tmpNode.Value = child.Path.ToString().Replace("/", "\\");
                            tmpNode.SelectAction = TreeNodeSelectAction.None;
                            tmpNode.PopulateOnDemand = false;
                            tmpNode.ImageUrl = adImageURL[(int)AdImages.User];
                            tvNode.ChildNodes.Add(tmpNode);
                            break;

                        case "group":
                            tmpNode.Text = child.Properties["Name"].Value.ToString();
                            tmpNode.Value = child.Path.ToString().Replace("/", "\\");
                            tmpNode.SelectAction = TreeNodeSelectAction.None;
                            tmpNode.PopulateOnDemand = false;
                            tmpNode.ImageUrl = adImageURL[(int)AdImages.Group];
                            tvNode.ChildNodes.Add(tmpNode);
                            break;

                        default:
                            tmpNode.Text = child.Properties["Name"].Value.ToString() + child.SchemaClassName.ToString();
                            tmpNode.Value = child.Path.ToString().Replace("/", "\\");
                            tmpNode.SelectAction = TreeNodeSelectAction.Expand;
                            tmpNode.PopulateOnDemand = true;
                            tmpNode.ImageUrl = adImageURL[(int)AdImages.Unknown];
                            tvNode.ChildNodes.Add(tmpNode);
                            break;
                    }
                }
            }

        }



    }



     private enum AdImages
	{
		AdRoot,
		Ou,
		Container,
		OpenContainer,
		Computer,
		User,
		Group,
		Unknown,
		Unavailable
	}

    
    string[] adImageURL = new string[]
    { 
        "images\\AdRoot.jpg",
		"images\\Ou.jpg",
		"images\\Container.jpg",
		"images\\OpenContainer.jpg",
		"images\\Computer.jpg",
		"images\\User.jpg",
		"images\\Group.jpg",
		"images\\Unknown.jpg",
		"images\\Unavailable.jpg"
    
    };

    protected void btnLoadDomain_Click(object sender, EventArgs e)
    {
        

        hdnAdPath.Value = txtDomainName.Text.ToString();
        hdnUserName.Value = txtUserName.Text.ToString();
        hdnUserPassword.Value = txtPassword.Text.ToString();
        hdnStatus.Value = "true";

        if (AuthenticateUser(txtDomainName.Text.ToString(), txtUserName.Text.ToString(), txtPassword.Text.ToString()))
        {
            LoadDomainDetailswithPath();
            lblStatus.Visible = false;

        }
        else
        {
            lblStatus.Text = "The specified domain either does not exist or could not be contacted.\nLogon failure: unknown user name or bad password.";
            lblStatus.Visible = true;
            tvDomainController.Visible = false; 
        }
    }

    protected void BtnLoad_Click(object sender, EventArgs e)
    {

        TreeNodeCollection checkedNodes = tvDomainController.CheckedNodes;
        dgSelectedValues.DataSource = checkedNodes;
        dgSelectedValues.DataBind();
         
    }

    public bool AuthenticateUser(String path, String user, String pass)
    {
        DirectoryEntry dirEntry = new DirectoryEntry(path, user, pass);
        try
        {
            Object nat;
            nat = dirEntry.NativeObject;
            return true;
        }
        catch (Exception ex)
        {
            return false;
        }
        finally
        {
            if (dirEntry != null)
                dirEntry.Dispose();

            dirEntry = null;
        }
    }
    protected void Submit_Click(object sender, EventArgs e)
    {
        // Find the node specified by the user.
        TreeNode node = tvDomainController.FindNode(Server.HtmlEncode(txtPath.Text));

        if (node != null)
        {
            // Indicate that the node was found.
            Message.Text = "The specified node (" + node.ValuePath + ") was found.";
            node.Checked = true;
        }
        else
        {
            // Indicate that the node is not in the TreeView control.
            Message.Text = "The specified node (" + txtPath.Text + ") is not in this TreeView control.";
        }
    }
}
